library ieee;
use ieee.std_logic_1164.all;


entity testbench is
end testbench;

architecture tb of testbench is
	constant T_clk : time := 20 ns;
	signal KEY : STD_LOGIC_VECTOR(1 downto 0);	
	signal SW  : STD_LOGIC_VECTOR(7 downto 0);	
	signal LEDR: STD_LOGIC_VECTOR(9 downto 0);
	signal HEX0 : STD_LOGIC_VECTOR(0 TO 6);
	signal HEX1 : STD_LOGIC_VECTOR(0 TO 6);
	signal HEX2 : STD_LOGIC_VECTOR(0 TO 6);
	signal HEX3 : STD_LOGIC_VECTOR(0 TO 6);
	signal clk_tb : std_logic;
begin
	-- connecting testbench signals
	UUT : entity work.part1 
	port map( KEY, SW, LEDR, HEX0, HEX1, HEX2, HEX3);

	-- continuous clock
	
	process
	begin
	clk_tb <= '1';
	wait for T_clk/2;
	clk_tb <= '0';
	wait for T_clk/2;
	end process;
	KEY(1) <= clk_tb;

	-- signals
	process
	begin
	KEY(0)<= '0'; 
	SW <= "00000000";
	wait for 40 ns;
	KEY(0)<= '1'; 
	SW <= "01000000";
	wait for 100 ns;
	KEY(0)<= '0'; 
	SW <= "00100000";
	wait for 20 ns;
	KEY(0)<= '1'; 
	SW <= "00100000";
	wait for 40 ns;
	KEY(0)<= '1'; 
	SW <= "11000000";
	wait for 200 ns;
	wait;
	end process;
end tb ;