LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.std_logic_signed.all;

entity part2 is
	port
	(
			KEY : in STD_LOGIC_VECTOR(1 downto 0);	
		   SW  : in STD_LOGIC_VECTOR(9 downto 0);	
			LEDR: out STD_LOGIC_VECTOR(9 downto 0);
			HEX0 : OUT STD_LOGIC_VECTOR(0 TO 6);
			HEX1 : OUT STD_LOGIC_VECTOR(0 TO 6);
			HEX2 : OUT STD_LOGIC_VECTOR(0 TO 6);
			HEX3 : OUT STD_LOGIC_VECTOR(0 TO 6)		
	);
end;


architecture behav of part2 is
   signal A, Ar, Sr : std_logic_vector(7 downto 0);
	signal S : std_logic_vector(8 downto 0);
	signal carry, overflow, carryr, overflowr : std_logic_vector(0 downto 0); 
	signal clk, reset, add_sub : std_logic;
	
begin


  A <= SW(7 downto 0) when add_sub='0' else ((not SW(7 downto 0)) + 1) when add_sub='1';
  add_sub <= SW(9);
  clk <= KEY(1);
  reset <= KEY(0);
  
Areg: entity work.reg
		generic map (A'length)
		port map (clk, reset, A, Ar);
		
				
		S <= std_logic_vector((Ar(7) & Ar) + (Sr(7) & Sr));
		
		carry(0) <= S(8);
       
	   overflow(0) <= (Ar(7) and Sr(7) and not S(7)) or (not Ar(7) and not Sr(7) and S(7));	 
		
		
Sreg: entity work.reg
		generic map (S(7 downto 0)'length)
		port map (clk, reset, S(7 downto 0), Sr);		

Creg: entity work.reg
		generic map (carry'length)
		port map (clk, reset, carry, carryr);		

Oreg: entity work.reg
		generic map (overflow'length)
		port map (clk, reset, overflow, overflowr);		
		
		LEDR(7 downto 0) <= Sr;
		LEDR(8) <= carryr(0);
		LEDR(9) <= overflowr(0);

H0: 
   entity work.DisplayDigit PORT MAP (Sr(3 downto 0), HEX0);	
H1: 
   entity work.DisplayDigit PORT MAP (Sr(7 downto 4), HEX1);	
H2: 
   entity work.DisplayDigit PORT MAP (Ar(3 downto 0), HEX2);	
H3: 
   entity work.DisplayDigit PORT MAP (Ar(7 downto 4), HEX3);	
	

end architecture;
	
	
	
