LIBRARY ieee;
USE ieee.std_logic_1164.all;

entity ArrayMultiplier4Bit is
	port
	(
		A, B : in  std_logic_vector(3 downto 0);
		M : out std_logic_vector(7 downto 0)
	);
end entity;


architecture struct of ArrayMultiplier4Bit is
   alias FA is work.FullAdder;
	signal A_AND_b0, A_AND_b1, A_AND_b2, A_AND_b3 : std_logic_vector(3 downto 0);
	signal S1, S2, S3: std_logic_vector(3 downto 0);
	signal B1, B2, B3: std_logic_vector(3 downto 0);
	signal c1, c2, c3: std_logic;

begin

   A_AND_b0 <= A when b(0)='1' else (others=>'0');
	A_AND_b1 <= A when b(1)='1' else (others=>'0');
	A_AND_b2 <= A when b(2)='1' else (others=>'0');
	A_AND_b3 <= A when b(3)='1' else (others=>'0');	
	
	M(0) <= A_AND_b0(0);
	B1 <= '0' & A_AND_b0(3 downto 1);	
	
Sum1: entity work.FourBitAdder(struct)
   port map(A_AND_b1, B1, '0', S1, c1);
	
	M(1) <= S1(0);
	B2 <= (c1 & S1(3 downto 1));	

Sum2: entity work.FourBitAdder(struct)
   port map(A_AND_b2, B2, '0', S2, c2);
	
	M(2) <= S2(0);
	B3 <= (c2 & S2(3 downto 1));

Sum3: entity work.FourBitAdder(struct)
   port map(A_AND_b3, B3, '0', S3, c3);
	
	M(6 downto 3) <= S3;
	M(7) <= c3;
	
end;