LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.std_logic_unsigned.all;

entity Multiply is
	port
	(
			A, B: in STD_LOGIC_VECTOR(7 downto 0);	
		   M : out STD_LOGIC_VECTOR(15 downto 0)
	);
end;


architecture tree of Multiply is
   signal A_AND_b0, A_AND_b1, A_AND_b2, A_AND_b3, A_AND_b4, A_AND_b5, A_AND_b6, A_AND_b7 : std_logic_vector(15 downto 0);
	signal PP1, PP2, PP3, PP4, PP5, PP6, PP7 : std_logic_vector(15 downto 0);
begin
	A_AND_b0 <= "00000000" & A when b(0)='1' else (others=>'0');
	A_AND_b1 <= "0000000" & A & "0" when b(1)='1' else (others=>'0');
	A_AND_b2 <= "000000" & A & "00" when b(2)='1' else (others=>'0');
	A_AND_b3 <= "00000" & A & "000" when b(3)='1' else (others=>'0');
	A_AND_b4 <= "0000" & A & "0000" when b(4)='1' else (others=>'0');
	A_AND_b5 <= "000" & A & "00000" when b(5)='1' else (others=>'0');
	A_AND_b6 <= "00" & A & "000000" when b(6)='1' else (others=>'0');
	A_AND_b7 <= "0" & A & "0000000" when b(7)='1' else (others=>'0');

	PP1 <= A_AND_b0 + A_AND_b1;
	PP2 <= A_AND_b2 + A_AND_b3;
	PP3 <= A_AND_b4 + A_AND_b5;
	PP4 <= A_AND_b6 + A_AND_b7;	
	PP5 <= PP1 + PP2;
	PP6 <= PP3 + PP4;
	M <= PP5 + PP6;

end architecture;
		
		