LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.std_logic_signed.all;

entity part5 is
	port
	(
		   KEY : in STD_LOGIC_VECTOR(1 downto 0);	
			SW  : in STD_LOGIC_VECTOR(9 downto 0);	
			LEDR: out STD_LOGIC_VECTOR(9 downto 0);
			HEX0 : OUT STD_LOGIC_VECTOR(0 TO 6);
			HEX1 : OUT STD_LOGIC_VECTOR(0 TO 6);
			HEX2 : OUT STD_LOGIC_VECTOR(0 TO 6);
			HEX3 : OUT STD_LOGIC_VECTOR(0 TO 6)		
	);
end;


architecture behav of part5 is
   signal A, B : std_logic_vector(7 downto 0);
	signal D, P : std_logic_vector(15 downto 0);
   signal clock, resetn, EA, EB: std_logic; 	
begin

  clock <= KEY(1);
  resetn <= KEY(0);
  EA <= SW(9);
  EB <= SW(8);

RegA: entity work.reg(behav)
  generic map(8)
  port map(clock, resetn, EA, SW(7 downto 0), A);
  
RegB: entity work.reg(behav)
  generic map(8)
  port map (clock, resetn, EB, SW(7 downto 0), B);
  
Mul: entity work.multiply(tree)
  port map (A, B, D);  

RegD: entity work.reg(behav)
  generic map(16)
  port map (clock, resetn, '1', D, P);
  
LEDR(7 downto 0) <= A when SW(9)='1' else B when SW(8)= '1' else "00000000";
LEDR(9 downto 8) <= SW(9 downto 8);

				
H0: 
   entity work.DisplayDigit PORT MAP (P(3 downto 0), HEX0);	
H1: 
   entity work.DisplayDigit PORT MAP (P(7 downto 4), HEX1);	
H2: 
   entity work.DisplayDigit PORT MAP (P(11 downto 8), HEX2);		
H3: 
   entity work.DisplayDigit PORT MAP (P(15 downto 12), HEX3);	
	

end architecture;
	
	
	
